﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Data.SqlClient;

namespace CommandTest
{
    class Program
    {
        static void Main(string[] args)
        {
            //接続文字列
            string constr = @"Data Source=(LocalDB)\v11.0;AttachDbFilename=C:\Work\Books.mdf;Integrated Security=True;Connect Timeout=30";

            //SqlConnectionオブジェクトを生成
            SqlConnection con = new SqlConnection(constr);

            //追加する情報を入力
            Console.WriteLine("登録するユーザー情報を入力してください。");
            Console.Write("ID：");
            int id = Int32.Parse(Console.ReadLine());
            Console.Write("ユーザー名：");
            string username = Console.ReadLine();
            Console.Write("パスワード：");
            string password = Console.ReadLine();
            Console.Write("氏名：");
            string name = Console.ReadLine();

            //入力した情報をもとにSQL文を作成
            string sql = "INSERT INTO Users VALUES(" + id + ", '" + username + "', '" + password + "', N'" + name + "')";

            //SqlCommandオブジェクトを生成
            SqlCommand cmd = new SqlCommand(sql, con);
            
            //実行予定のSQL文を表示
            Console.WriteLine("実行するSQL文：{0}", cmd.CommandText);

            //データベースを開く
            con.Open();

            //SqlTransactionオブジェクトを取得
            SqlTransaction trans = con.BeginTransaction();

            //SqlCommandオブジェクトにSqlTransactionオブジェクトをセット
            cmd.Transaction = trans;

            //SQL文を実行する
            int ret = cmd.ExecuteNonQuery();

            //変更のあった行数を表示する
            Console.WriteLine("変更のあった件数：{0}", ret);

            //確定か取消しを入力
            Console.Write("1)確定 2)取消し(デフォルト)：");
            string input = Console.ReadLine();

            switch (input)
            {
                case "1":
                    //確定
                    trans.Commit();
                    Console.WriteLine("確定しました。");
                    break;
                default:
                    //取消し
                    trans.Rollback();
                    Console.WriteLine("取り消しました。");
                    break;
            }

            //データベースを閉じる
            con.Close();
            Console.ReadLine();
        }
    }
}
